
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

(* IA.INC *)

procedure croix(i,j:byte);
(* Affiche une croix aux coordonnes i,j de la grille *)
begin
  (* Masquer la souris *)
  souris_off;
  (* Construire la croix *)
  putpixel(scrn_pg,(i-1)*28+14,(j-1)*28+13,246);
  putpixel(scrn_pg,(i-1)*28+14,(j-1)*28+15,246);
  putpixel(scrn_pg,(i-1)*28+14,(j-1)*28+14,184);
  putpixel(scrn_pg,(i-1)*28+13,(j-1)*28+14,246);
  putpixel(scrn_pg,(i-1)*28+15,(j-1)*28+14,246);
  (* Afficher la souris *)
  souris_on;
end;

procedure IA_attaque(piece:Tpion; var meilleur:Tposition; IAide:boolean);
(****************************************************************************)
(* Calcule toutes les attaques possibles  partir du tableau global des     *)
(* attaques avec la pice passe en paramtre et renvoie l'attaque qui      *)
(* donne le plus de points.                                                 *)
(* Si le paramtre AIDE est activ, les meilleurs coups trouvs sont        *)
(* affichs  l'cran par une 'croix'.                                      *)
(****************************************************************************)
var cmpt:byte;
    maximum_score:word;
    meilleurs_coups:array [1..13] of Tposition; (* Tableau des meilleurs coups *)
    nb_meilleurs_coups:byte;                    (* Nombre de meilleurs coups *)
begin
  maximum_score:=0; (* Pour l'instant, le meilleur score en nul *)
  with attaque do begin
(*** Calculer tous les scores possibles ***)
    for cmpt:=1 to nombre do begin
      (* Placer le pion sur la grille *)
      grille[coup[cmpt].position.x,coup[cmpt].position.y]:=piece;
      (* Calculer le score *)
      coup[cmpt].score:=score(grille,true);
      (* Enlever le pion de la grille *)
      grille[coup[cmpt].position.x,coup[cmpt].position.y]:=vide;
      (* Si ce coup raporte plus de point que les autres, il devient de meilleur
         score *)
      if coup[cmpt].score>maximum_score then maximum_score:=coup[cmpt].score;
    end;
(*** Isoler tous les meilleurs_coups ***)
    nb_meilleurs_coups:=0;
    (* Retrouver tous les coups rapportant le plus de points *)
    for cmpt:=1 to nombre do if coup[cmpt].score=maximum_score then begin
      (* Si l'AIDE est active, afficher le coup *)
      if IAide then croix(coup[cmpt].position.x,coup[cmpt].position.y);
      inc(nb_meilleurs_coups);
      meilleurs_coups[nb_meilleurs_coups]:=coup[cmpt].position;
    end;
  end;
(*** Choisir un des meilleurs coups ***)
  meilleur:=meilleurs_coups[random(nb_meilleurs_coups)+1];
end;


procedure IA_defense(piece:Tpion; var meilleur:Tposition; IAide:boolean);
(****************************************************************************)
(* Choisi la meilleur dfense sur la grille courante avec le pion pass en  *)
(* paramtre. Pour cel, cette routine teste toutes les dfenses possibles  *)
(* et choisit la plus mauvaise "meilleure contre-attaque".                  *)
(* Si le paramtre AIDE est activ, les meilleurs coups trouvs sont        *)
(* affichs  l'cran par une 'croix'.                                      *)
(****************************************************************************)
var i,j,h:byte;
(* Tableau des toutes les dfenses possibles *)
    defense:array [1..7,1..7] of record
              valide:boolean; (* validit du coups : case dj occupe ? *)
              meilleure_riposte:word; (* Meilleure contre-attaque de ce coup *)
            end;
    minimum_score:word;
    test:Tposition;
    meilleurs_coups:array [1..7*7] of Tposition; (* Tableau des meilleurs coups *)
    nb_meilleurs_coups:byte;                     (* Nombre de meilleurs coups *)
begin
  minimum_score:=word(-1); (* Initialiser avec un score maximum *)
(*** Calculer tous les scores possibles ***)
  for i:=1 to 7 do for j:=1 to 7 do begin
    (* Afficher  l'cran la progression de la rflexion de l'IA *)
    copyblock(i*7+j,11,sprt_pg,175,0,scrn_pg,263,185,true);
    (* Si la case (i,j) est vide, alors le coup est possible *)
    with defense[i,j] do if grille[i,j]=vide then begin
      valide:=true;
      test.x:=i;
      test.y:=j;
      (* Calculer toutes les attaques possibles *)
      attaques(test);
      (* Isoler la meilleure *)
      IA_attaque(piece,test,false);
      (* Jouer la meilleure contre-attaque *)
      grille[test.x,test.y]:=piece;
      (* Calculer le score de la grille obtenue *)
      meilleure_riposte:=score(grille,true);
      (* Enlever le pion ! *)
      grille[test.x,test.y]:=vide;
      (* Si cette meilleure contre-attaque est mauvaise, on la garde ! *)
      if meilleure_riposte<minimum_score then minimum_score:=meilleure_riposte;
    end else defense[i,j].valide:=false;
  end;
  nb_meilleurs_coups:=0;
(*** Isoler tous les meilleurs_coups ***)
  for i:=1 to 7 do for j:=1 to 7 do with defense[i,j] do
    if valide and (meilleure_riposte=minimum_score) then begin
      inc(nb_meilleurs_coups);
      (* Si l'AIDE est active, afficher le coup *)
      if IAide then croix(i,j);
      meilleurs_coups[nb_meilleurs_coups].x:=i;
      meilleurs_coups[nb_meilleurs_coups].y:=j;
    end;
(*** Choisir un des meilleurs coups ***)
  meilleur:=meilleurs_coups[random(nb_meilleurs_coups)+1];
end;