
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

(* INFO.INC *)

procedure copy184(source,dest:pointer); assembler;
(* Comme copypage (unit Mode 13h), cette procedure copie la page source vers
   la page destination mais uniquement sur 184 lignes.
   Ceci permet de masquer les lettres qui viennent d'apparaitre en bas de la
   page de construction pour donner l'impression qu'elles arrivent en dehors
   de l'cran *)
asm
  push ds
  les di,dest
  lds si,source
  mov cx,320*184/4      (* 184 lignes *)
  db 66h;rep movsw      (* Copier *)
  pop ds
end;

procedure copydec(source,dest:pointer); assembler;
(* Copie la page source vers la page destination une ligne plus haut.
   Ainsi, il est facile d'implmenter le scrolling des lettres vers le haut. *)
asm
  push ds
  les di,dest           (* Normal pour la destination ... *)
  lds si,source
  add si,320            (* ... Mais une ligne plus bas dans la source *)
  mov cx,320*199/4      (* Toutes les lignes sauf une *)
  db 66h;rep movsw      (* Copier *)
  pop ds
end;

procedure info;
(****************************************************************************)
(* Affiche un texte droulant donnant des informations sur le jeu.          *)
(* Pour cel, une ligne de texte est ajoute en bas de la page de           *)
(* construction toutes les 14 boucles. A chaques boucles, cette page est    *)
(* dcal de une ligne vers le haut est est colle sur un fond.             *)
(* Le texte  affich est lu dans le fichier info.dat, qui est au format    *)
(* texte habituel. Lorsque la fin du fichier est atteinte, on recommence au *)
(* dbut. Le texte dfile donc tant que l'utilisateur ne clique pas         *)
(****************************************************************************)
const haut=14;           (* Hauteur de la police *)
var inf:text;            (* Fichier texte d'informations *)
    cmpt,tcol,fcol:byte; (* Compteur de ligne, couleurs texte et fond *)
    code:word;
    s:string;            (* Ligne lue dans le fichier *)
begin
  souris_off;                  (* Effacer la souris *)
  fillchar(pal,768,0);
  setpal;                      (* Palette noire *)
  loadpcx('info.pcx',sprt_pg); (* Charger l'image de fond *)
  clearpage(scrn_pg);          (* Effacer l'cran *)
  copy184(sprt_pg,scrn_pg);    (* Afficher l'image de fond  l'cran *)
  fade_in;                     (* Fondu d'entre *)
  clearpage(make_pg);          (* Effacer la page de construction *)
  assign(inf,'info.dat');
  reset(inf);                  (* Ouvrir le fichier de texte *)
  cmpt:=0;
  cmpt:=haut-1;
  repeat until souris_bout<>1; (* Attendre que l'utilisateur lache la souris *)
  repeat
    inc(cmpt);                 (* 1 ligne graphique de plus *)
    if cmpt=haut then begin    (* Si on est 14 lignes graphiques plus bas *)
      readln(inf,s);           (* on affiche le texte *)
      if eof(inf) then reset(inf);
      if s[1]='[' then begin   (* Si le texte est de la forme [XXX,YYY] alors *)
         val(copy(s,2,3),tcol,code); (* XXX est la nouvelle couleur du texte *)
         val(copy(s,6,3),fcol,code); (* YYY est la nouvelle couleur de fond *)
      end else begin
        outtextxy(make_pg,0,198-haut,s,tcol,fcol); (* Sinon afficher le texte *)
      end;
      cmpt:=0;
    end;
    copydec(make_pg,make_pg);  (* Dcaler une ligne vers le haut *)
    copy184(sprt_pg,fond_pg);  (* Copier l'image de fond *)
    (* Coller par dessus le texte en transparence *)
    copyblock(320,200,make_pg,0,0,fond_pg,0,0,false);
    (* Patienter 3 passages de rayon cathodique (minimum 3/70 secondes) *)
    wdelay(3);
    copy184(fond_pg,scrn_pg);  (* Afficher le rsultat *)
  until souris_bout=1;         (* Jusqu' ce qu'on clique le bouton gauche *)
  close(inf);                  (* Fermer le fichier ! *)
  fade_out;                    (* Fondu de sortie *)
  clearpage(scrn_pg);          (* Effacer l'cran *)
  souris_on;                   (* Afficher la souris *)
end;