
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

(* SCORE.INC *)

function score(Vgrille:Tgrille; IA:boolean):word;
(****************************************************************************)
(* Calcule le score d'une grille.                                           *)
(*  Si la grille n'est pas pleine, la valeur renvoye est le score actuel. *)
(*  Les symtries de longueurs impaires (3/5/7) sont comptabilise mme si *)
(*   le pion central est manquant !  En effet, quel que soit la couleur de  *)
(*   ce pion, la symtrie sera ralise...                                  *)
(*  Si le paramtre IA est a TRUE, le score total des lignes et des        *)
(*   colonnes est incrment de 1 afin de ne jamais annuler le produit.     *)
(*   Ainsi, l'ordinateur ne fait pas 'btement' des alignement sur un axe.  *)
(****************************************************************************)
var long:byte; (* Longueur de la combinaison en cours de test *)
    posi:byte; (* Position actuelle du test *)
    deb,fin:byte; (* Indice debut/fin du test en cours *)
    Sligne:word; (* Valeur du score ligne *)
    Scolon:word; (* Valeur du score colonne *)
    i,j:byte;
begin
(*** Calcul du score des lignes ***)
  if IA then Sligne:=1 else Sligne:=0;
  for j:=1 to 7 do
  (* Pour toutes les longueurs de symtries possibles *)
  for long:=2 to 7 do
    (* Pour toutes les positions de ces symtries *)
    for posi:=1 to 8-long do begin
      deb:=posi;
      fin:=posi+long-1;
      (* Tant que les pions de dbut et de fin son les mmes, que les indices
         ne se sont pas croiss et que les cases pointes ne sont pas vide *)
      while (Vgrille[deb,j]=Vgrille[fin,j])
        and (deb<fin)
        and (Vgrille[deb,j]<>vide)
        and (Vgrille[fin,j]<>vide)
        do begin
          (* Dcaler les indices *)
          inc(deb);
          dec(fin);
        end;
      (* Si les indices se sont croiss, on marque des points *)
      if not (deb<fin) then inc(Sligne,long);
    end;
(*** Calcul du score des colonnes ***)
  if IA then Scolon:=1 else Scolon:=0;
  for i:=1 to 7 do
  for long:=2 to 7 do
    for posi:=1 to 8-long do begin
      deb:=posi;
      fin:=posi+long-1;
      while (Vgrille[i,deb]=Vgrille[i,fin])
        and (deb<fin)
        and (Vgrille[i,deb]<>vide)
        and (Vgrille[i,fin]<>vide)
        do begin
          inc(deb);
          dec(fin);
        end;
      if not (deb<fin) then inc(Scolon,long);
    end;
(* Le score final est le produit du score ligne par colonne *)
  score:=Sligne*Scolon;
end;

